#ifndef __transverbEdit
#include "transverbEdit.hpp"
#endif

#ifndef __transverbEditor
#include "transverbEditor.hpp"
#endif

AudioEffect* createEffectInstance (audioMasterCallback audioMaster)
{
    AudioEffect* effect = new TransverbEdit (audioMaster);
	if (!effect)
		return 0;
	
	return effect;
}

//-----------------------------------------------------------------------------
TransverbEdit::TransverbEdit(audioMasterCallback audioMaster)
 : Transverb(audioMaster)
{
	editor = new TransverbEditor (this);
}

//-----------------------------------------------------------------------------
TransverbEdit::~TransverbEdit()
{
	// the editor gets deleted by the AudioEffect base class
}

//-----------------------------------------------------------------------------
void TransverbEdit::setParameter(VstInt32 index, float value)
{
	PLUGIN::setParameter(index, value);

	if (editor)
		((AEffGUIEditor*)editor)->setParameter(index, value);
}
