/*--------- by Tom Murphy 7 & Marc Poirier  ][  September 2001 ---------*/

#ifndef __transverbEditor
#define __transverbEditor

#ifndef __transverb
#include "transverb.hpp"
#endif

#include "dfxgui.h"
#include "multikick.hpp"

#include <stdio.h>
#include <math.h>
#include <stdlib.h>

#include "aeffguieditor.h"




//const CColor kBackgroundCColor = {59, 84, 165, 0};
const CColor kBlueTextCColor = CColor(103, 161, 215);
#define FINE_INCR   0.0001f


//-----------------------------------------------------------------------
class TransverbEditor : public AEffGUIEditor, public IControlListener
{
public:
	TransverbEditor(AudioEffect *effect);
	virtual ~TransverbEditor();

protected:
	virtual bool getRect(ERect **rect);
	virtual bool open(void *ptr);
	virtual void close();

	virtual void setParameter(VstInt32 index, float value);
    virtual void valueChanged (CControl* pControl);

	virtual void idle();

private:
	float speedDown(long speedTag, long speedModeTag);
	float speedUp(long speedTag, long speedModeTag);
	float nearestIntegerBelow(float number);
	float nearestIntegerAbove(float number);

	// controls
	CHorizontalSlider *speed1Fader;
	CHorizontalSlider *feed1Fader;
	CHorizontalSlider *dist1Fader;
	CHorizontalSlider *speed2Fader;
	CHorizontalSlider *feed2Fader;
	CHorizontalSlider *dist2Fader;
	CHorizontalSlider *bsizeFader;
	//
	CVerticalSlider *drymixFader;
	CVerticalSlider *mix1Fader;
	CVerticalSlider *mix2Fader;
	//
	MultiKick *qualityButton;
	MultiKick *tomsoundButton;
	CKickButton *randomButton;
	//
	CKickButton *speed1FineDownButton;
	CKickButton *speed1FineUpButton;
	CFineTuneButton *feed1FineDownButton;
	CFineTuneButton *feed1FineUpButton;
	CFineTuneButton *dist1FineDownButton;
	CFineTuneButton *dist1FineUpButton;
	CKickButton *speed2FineDownButton;
	CKickButton *speed2FineUpButton;
	CFineTuneButton *feed2FineDownButton;
	CFineTuneButton *feed2FineUpButton;
	CFineTuneButton *dist2FineDownButton;
	CFineTuneButton *dist2FineUpButton;
	CFineTuneButton *bsizeFineDownButton;
	CFineTuneButton *bsizeFineUpButton;
	//
	MultiKick *speed1modeButton;
	MultiKick *speed2modeButton;
	//
	COnOffButton *midiLearnButton;
	CKickButton *midiResetButton;
	//
	CWebLink *DFXlink;
	CWebLink *SuperDFXlink;
	CWebLink *SmartElectronixLink;

	// parameter value display boxes
	CTextEdit *speed1TextEdit;
	CParamDisplay *feed1Display;
	CParamDisplay *dist1Display;
	CTextEdit *speed2TextEdit;
	CParamDisplay *feed2Display;
	CParamDisplay *dist2Display;
	CParamDisplay *bsizeDisplay;

	// graphics
	CBitmap *gBackground;
	CBitmap *gPurpleWideFaderSlide;
	CBitmap *gGreyWideFaderSlide;
	CBitmap *gPurpleTallFaderSlide;
	CBitmap *gPurpleWideFaderHandle;
	CBitmap *gGreyWideFaderHandle;
	CBitmap *gTallFaderHandle;
	CBitmap *gGlowingPurpleWideFaderHandle;
	CBitmap *gGlowingGreyWideFaderHandle;
	CBitmap *gGlowingTallFaderHandle;
	CBitmap *gFineDownButton;
	CBitmap *gFineUpButton;
	CBitmap *gSpeedModeButton;
	CBitmap *gQualityButton;
	CBitmap *gOnOffButton;
	CBitmap *gRandomButton;
	CBitmap *gMidiLearnButton;
	CBitmap *gMidiResetButton;
	CBitmap *gDFXlink;
	CBitmap *gSuperDFXlink;
	CBitmap *gSmartElectronixLink;
	CBitmap *gSpeedConvertButton;

	char *speedString;

	CHorizontalSlider **faders;
	CVerticalSlider **tallFaders;

	VstChunk *chunk;
};

#endif